# Distributed under the terms of the GNU General Public License v2

#inherit flag-o-matic libtool
inherit flag-o-matic

IUSE="nls"

#need to check what gcc version we are running

GCC_PV=$(gcc -dumpversion)

DESCRIPTION="D GCC Frontend"
SRC_URI="http://home.earthlink.net/~dvdfrdmn/d/d-for-gcc-r1f.tgz
		ftp://gcc.gnu.org/pub/gcc/releases/gcc-${GCC_PV}/gcc-${GCC_PV}.tar.bz2"

HOMEPAGE="http://home.earthlink.net/~dvdfrdmn/d/"

SLOT="0"
KEYWORDS="~x86"
LICENSE="GPL-2"
S="${WORKDIR}/gcc-${GCC_PV}"

DEPEND="virtual/glibc
		>=sys-devel/gcc-3.3.2"

src_unpack() {
	unpack "gcc-${GCC_PV}.tar.bz2"
	
	cd "${S}/gcc"
	
	unpack "d-for-gcc-r1f.tgz"
	
	if [ "${GCC_PV}" == "3.4.0" ]
	then
	    patch -p1 < d/patch-gcc-3.4-20040317
	    
	elif [ "${GCC_PV}" == "3.3.3" -o "${GCC_PV}" == "3.3.2" ]
	then
	    patch -p1 < d/patch-gcc-3.3.2
	fi
}

src_compile() {
	einfo "Configuring GCC for GDC inclusion..."

	cd ${S}
	./configure --prefix=/usr --enable-shared --enable-threads=posix --enable-languages=d 

	einfo "Building GDC..."
	gmake	
}

src_install () {
    dobin ${S}/gcc/gdc
    dodir "`gcc-config --get-lib-path`"
    cp ${S}/gcc/cc1d ${D}"`gcc-config --get-lib-path`"
}
